// generated by Fast Light User Interface Designer (fluid) version 1.0107

#include "EffUI.h"
//Copyright (c) 2002-2005 Nasca Octavian Paul
//License: GNU GPL version 2

EQGraph::EQGraph(int x,int y, int w, int h, const char *label):Fl_Box(x,y,w,h,label) {
  eff=NULL;
maxdB=30;
}

void EQGraph::init(EffectMgr *eff_) {
  eff=eff_;
oldx=-1;
khzval=-1;
}

void EQGraph::draw_freq_line(REALTYPE freq,int type) {
  fl_color(FL_GRAY);
REALTYPE freqx=getfreqpos(freq);
switch(type){
  case 0:if (active_r()) fl_color(FL_WHITE);
            else fl_color(205,205,205);
         fl_line_style(FL_SOLID);
         break;
  case 1:fl_line_style(FL_DOT);break;
  case 2:fl_line_style(FL_DASH);break;
}; 


if ((freqx>0.0)&&(freqx<1.0))
   fl_line(x()+(int) (freqx*w()),y(),
   x()+(int) (freqx*w()),y()+h());
}

void EQGraph::draw() {
  int ox=x(),oy=y(),lx=w(),ly=h(),i,iy,oiy;
REALTYPE freqx;

if (active_r()) fl_color(0,70,150);
       else fl_color(80,120,160);
fl_rectf(ox,oy,lx,ly);


//draw the lines
fl_color(FL_GRAY);

fl_line_style(FL_SOLID);
fl_line(ox+2,oy+ly/2,ox+lx-2,oy+ly/2);

freqx=getfreqpos(1000.0);
if ((freqx>0.0)&&(freqx<1.0))
   fl_line(ox+(int) (freqx*lx),oy,
    ox+(int) (freqx*lx),oy+ly);

for (i=1;i<10;i++){
   if(i==1){
     draw_freq_line(i*100.0,0);
     draw_freq_line(i*1000.0,0);
   }else 
    if (i==5){
      draw_freq_line(i*10.0,2);
      draw_freq_line(i*100.0,2);
      draw_freq_line(i*1000.0,2);
    }else{
      draw_freq_line(i*10.0,1);
      draw_freq_line(i*100.0,1);
      draw_freq_line(i*1000.0,1);
    };
};

draw_freq_line(10000.0,0);
draw_freq_line(20000.0,1);


fl_line_style(FL_DOT);
int GY=6;if (ly<GY*3) GY=-1;
for (i=1;i<GY;i++){
   int tmp=(int)(ly/(REALTYPE)GY*i);
   fl_line(ox+2,oy+tmp,ox+lx-2,oy+tmp);
};


//draw the frequency response
if (active_r()) fl_color(FL_YELLOW);
       else fl_color(200,200,80);
fl_line_style(FL_SOLID);
oiy=getresponse(ly,getfreqx(0.0));
for (i=1;i<lx;i++){
   REALTYPE frq=getfreqx(i/(REALTYPE) lx);
   if (frq>SAMPLE_RATE/2) break;
   iy=getresponse(ly,frq);
   if ((oiy>=0) && (oiy<ly) &&
       (iy>=0) && (iy<ly) )
        fl_line(ox+i-1,oy+ly-oiy,ox+i,oy+ly-iy);
   oiy=iy;
};
}

int EQGraph::getresponse(int maxy,REALTYPE freq) {
  REALTYPE dbresp=eff->getEQfreqresponse(freq);
int idbresp=(int) ((dbresp/maxdB+1.0)*maxy/2.0);


//fprintf(stderr,"%.5f\n",(dbresp/maxdB+1.0)*maxy/2.0);


return(idbresp);
}

REALTYPE EQGraph::getfreqx(REALTYPE x) {
  if (x>1.0) x=1.0;
return(20.0*pow(1000.0,x));
}

REALTYPE EQGraph::getfreqpos(REALTYPE freq) {
  if (freq<0.00001) freq=0.00001;
return(log(freq/20.0)/log(1000.0));
}

void EffUI::cb_revp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());

refresh(eff);
}
void EffUI::cb_revp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp_i(o,v);
}

Fl_Menu_Item EffUI::menu_revp[] = {
 {"Cathedral 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Cathedral 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Cathedral 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Hall 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Hall 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Room 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Room 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Basement", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Tunnel", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echoed 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echoed 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Very Long 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Very Long 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_revp10_i(Fl_Choice* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void EffUI::cb_revp10(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp10_i(o,v);
}

Fl_Menu_Item EffUI::menu_revp10[] = {
 {"Random", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Freeverb", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_revp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_revp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp0_i(o,v);
}

void EffUI::cb_revp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_revp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp1_i(o,v);
}

void EffUI::cb_revp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_revp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp2_i(o,v);
}

void EffUI::cb_revp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_revp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp3_i(o,v);
}

void EffUI::cb_revp4_i(WidgetPDial* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_revp4(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp4_i(o,v);
}

void EffUI::cb_revp5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_revp5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp5_i(o,v);
}

void EffUI::cb_revp6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_revp6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp6_i(o,v);
}

void EffUI::cb_revp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_revp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp7_i(o,v);
}

void EffUI::cb_revp8_i(WidgetPDial* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_revp8(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp8_i(o,v);
}

void EffUI::cb_revp9_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_revp9(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp9_i(o,v);
}

void EffUI::cb_revp11_i(WidgetPDial* o, void*) {
  int x=64;
if (Fl::event_button1()) x=(int)o->value();
   else o->value(x);
eff->seteffectpar(11,x);
}
void EffUI::cb_revp11(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_revp11_i(o,v);
}

void EffUI::cb_echop_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_echop(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop_i(o,v);
}

Fl_Menu_Item EffUI::menu_echop[] = {
 {"Echo 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echo 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echo 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Simple Echo", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Canyon", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Feedback Echo", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_echop0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_echop0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop0_i(o,v);
}

void EffUI::cb_echop1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_echop1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop1_i(o,v);
}

void EffUI::cb_echop2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_echop2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop2_i(o,v);
}

void EffUI::cb_echop3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_echop3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop3_i(o,v);
}

void EffUI::cb_echop4_i(WidgetPDial* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_echop4(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop4_i(o,v);
}

void EffUI::cb_echop5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_echop5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop5_i(o,v);
}

void EffUI::cb_echop6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_echop6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_echop6_i(o,v);
}

void EffUI::cb_chorusp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_chorusp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp_i(o,v);
}

Fl_Menu_Item EffUI::menu_chorusp[] = {
 {"Chorus 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Chorus 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Chorus 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Celeste 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Celeste 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_chorusp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_chorusp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp0_i(o,v);
}

void EffUI::cb_chorusp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_chorusp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp1_i(o,v);
}

void EffUI::cb_chorusp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_chorusp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp2_i(o,v);
}

void EffUI::cb_chorusp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_chorusp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp3_i(o,v);
}

void EffUI::cb_chorusp5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_chorusp5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp5_i(o,v);
}

void EffUI::cb_chorusp6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_chorusp6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp6_i(o,v);
}

void EffUI::cb_chorusp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_chorusp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp7_i(o,v);
}

void EffUI::cb_chorusp8_i(WidgetPDial* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_chorusp8(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp8_i(o,v);
}

void EffUI::cb_chorusp9_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_chorusp9(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp9_i(o,v);
}

void EffUI::cb_Flange_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void EffUI::cb_Flange(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_Flange_i(o,v);
}

void EffUI::cb_chorusp11_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(11,(int) o->value());
}
void EffUI::cb_chorusp11(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp11_i(o,v);
}

void EffUI::cb_chorusp4_i(Fl_Choice* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_chorusp4(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_chorusp4_i(o,v);
}

Fl_Menu_Item EffUI::menu_chorusp4[] = {
 {"SINE", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"TRI", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_phaserp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_phaserp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp_i(o,v);
}

Fl_Menu_Item EffUI::menu_phaserp[] = {
 {"Phaser 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 6", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_phaserp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_phaserp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp0_i(o,v);
}

void EffUI::cb_phaserp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_phaserp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp1_i(o,v);
}

void EffUI::cb_phaserp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_phaserp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp2_i(o,v);
}

void EffUI::cb_phaserp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_phaserp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp3_i(o,v);
}

void EffUI::cb_phaserp5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_phaserp5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp5_i(o,v);
}

void EffUI::cb_phaserp6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_phaserp6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp6_i(o,v);
}

void EffUI::cb_phaserp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_phaserp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp7_i(o,v);
}

void EffUI::cb_phaserp9_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_phaserp9(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp9_i(o,v);
}

void EffUI::cb_phaserp10_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void EffUI::cb_phaserp10(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp10_i(o,v);
}

void EffUI::cb_phaserp4_i(Fl_Choice* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_phaserp4(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp4_i(o,v);
}

Fl_Menu_Item EffUI::menu_phaserp4[] = {
 {"SINE", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"TRI", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_phaserp8_i(Fl_Counter* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_phaserp8(Fl_Counter* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp8_i(o,v);
}

void EffUI::cb_phaserp11_i(WidgetPDial* o, void*) {
  eff->seteffectpar(11,(int) o->value());
}
void EffUI::cb_phaserp11(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_phaserp11_i(o,v);
}

void EffUI::cb_awp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_awp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp_i(o,v);
}

Fl_Menu_Item EffUI::menu_awp[] = {
 {"Alienwah 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_awp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_awp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp0_i(o,v);
}

void EffUI::cb_awp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_awp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp1_i(o,v);
}

void EffUI::cb_awp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_awp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp2_i(o,v);
}

void EffUI::cb_awp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_awp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp3_i(o,v);
}

void EffUI::cb_awp5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_awp5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp5_i(o,v);
}

void EffUI::cb_awp6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_awp6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp6_i(o,v);
}

void EffUI::cb_awp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_awp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp7_i(o,v);
}

void EffUI::cb_awp9_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_awp9(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp9_i(o,v);
}

void EffUI::cb_awp4_i(Fl_Choice* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_awp4(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp4_i(o,v);
}

Fl_Menu_Item EffUI::menu_awp4[] = {
 {"SINE", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"TRI", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_awp10_i(WidgetPDial* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void EffUI::cb_awp10(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp10_i(o,v);
}

void EffUI::cb_awp8_i(Fl_Counter* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_awp8(Fl_Counter* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_awp8_i(o,v);
}

void EffUI::cb_distp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_distp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp_i(o,v);
}

Fl_Menu_Item EffUI::menu_distp[] = {
 {"Overdrive 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Overdrive 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"A. Exciter 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"A. Exciter 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Guitar Amp", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Quantisize", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_distp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_distp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp0_i(o,v);
}

void EffUI::cb_distp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_distp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp1_i(o,v);
}

void EffUI::cb_distp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_distp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp2_i(o,v);
}

void EffUI::cb_distp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_distp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp3_i(o,v);
}

void EffUI::cb_distp4_i(WidgetPDial* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_distp4(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp4_i(o,v);
}

void EffUI::cb_distp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_distp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp7_i(o,v);
}

void EffUI::cb_distp8_i(WidgetPDial* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_distp8(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp8_i(o,v);
}

void EffUI::cb_distp5_i(Fl_Choice* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_distp5(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp5_i(o,v);
}

Fl_Menu_Item EffUI::menu_distp5[] = {
 {"Atan", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Asym1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pow", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Sine", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Qnts", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Zigzg", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lmt", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LmtU", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LmtL", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"ILmt", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Clip", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Asym2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pow2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Sgm", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_distp6_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_distp6(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp6_i(o,v);
}

void EffUI::cb_distp9_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_distp9(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp9_i(o,v);
}

void EffUI::cb_distp10_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void EffUI::cb_distp10(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_distp10_i(o,v);
}

void EffUI::cb_eqp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
eqgraph->redraw();
}
void EffUI::cb_eqp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_eqp0_i(o,v);
}

void EffUI::cb_bandcounter_i(Fl_Counter* o, void*) {
  eqband=(int) o->value();
int npb=eqband*5+10;

int type=eff->geteffectpar(npb);
typechoice->value(type);

if (type>6) gaindial->activate();
 else gaindial->deactivate();

if (type==0) bandgroup->deactivate();
else bandgroup->activate();

int freq=eff->geteffectpar(npb+1);
freqdial->value(freq);

int gain=eff->geteffectpar(npb+2);
gaindial->value(gain);

int q=eff->geteffectpar(npb+3);
qdial->value(q);

int dbl=eff->geteffectpar(npb+4);
stagescounter->value(dbl);
}
void EffUI::cb_bandcounter(Fl_Counter* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_bandcounter_i(o,v);
}

void EffUI::cb_freqdial_i(WidgetPDial* o, void*) {
  int np=eqband*5+11;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void EffUI::cb_freqdial(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_freqdial_i(o,v);
}

void EffUI::cb_gaindial_i(WidgetPDial* o, void*) {
  int np=eqband*5+12;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void EffUI::cb_gaindial(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_gaindial_i(o,v);
}

void EffUI::cb_qdial_i(WidgetPDial* o, void*) {
  int np=eqband*5+13;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void EffUI::cb_qdial(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_qdial_i(o,v);
}

void EffUI::cb_stagescounter_i(Fl_Counter* o, void*) {
  int np=eqband*5+14;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void EffUI::cb_stagescounter(Fl_Counter* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_stagescounter_i(o,v);
}

void EffUI::cb_typechoice_i(Fl_Choice* o, void*) {
  int np=eqband*5+10;
eff->seteffectpar(np,(int) o->value());
bandcounter->do_callback();
eqgraph->redraw();
}
void EffUI::cb_typechoice(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_typechoice_i(o,v);
}

Fl_Menu_Item EffUI::menu_typechoice[] = {
 {"OFF", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lp1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Hp1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Hp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Bp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"N2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pk", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LSh", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"HSh", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_dfp_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void EffUI::cb_dfp(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp_i(o,v);
}

Fl_Menu_Item EffUI::menu_dfp[] = {
 {"WahWah", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"AutoWah", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Sweep", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"VocalMorph1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"VocalMorph2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_dfp0_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void EffUI::cb_dfp0(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp0_i(o,v);
}

void EffUI::cb_dfp1_i(WidgetPDial* o, void*) {
  eff->seteffectpar(1,(int) o->value());
}
void EffUI::cb_dfp1(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp1_i(o,v);
}

void EffUI::cb_dfp2_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void EffUI::cb_dfp2(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp2_i(o,v);
}

void EffUI::cb_dfp3_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void EffUI::cb_dfp3(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp3_i(o,v);
}

void EffUI::cb_dfp5_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void EffUI::cb_dfp5(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp5_i(o,v);
}

void EffUI::cb_dfp6_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void EffUI::cb_dfp6(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp6_i(o,v);
}

void EffUI::cb_dfp4_i(Fl_Choice* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void EffUI::cb_dfp4(Fl_Choice* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_dfp4_i(o,v);
}

Fl_Menu_Item EffUI::menu_dfp4[] = {
 {"SINE", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"TRI", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void EffUI::cb_Filter_i(Fl_Button*, void*) {
  filterwindow->show();
}
void EffUI::cb_Filter(Fl_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_Filter_i(o,v);
}

void EffUI::cb_dfp7_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void EffUI::cb_dfp7(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_dfp7_i(o,v);
}

void EffUI::cb_dfp9_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void EffUI::cb_dfp9(WidgetPDial* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_dfp9_i(o,v);
}

void EffUI::cb_dfp8_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void EffUI::cb_dfp8(Fl_Check_Button* o, void* v) {
  ((EffUI*)(o->parent()->parent()->user_data()))->cb_dfp8_i(o,v);
}

void EffUI::cb_Close_i(Fl_Button*, void*) {
  filterwindow->hide();
}
void EffUI::cb_Close(Fl_Button* o, void* v) {
  ((EffUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

EffUI::EffUI(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  eff=NULL;
filterwindow=NULL;
}

EffUI::~EffUI() {
  effnullwindow->hide();//delete (effnullwindow);
effreverbwindow->hide();//delete (effreverbwindow);
effechowindow->hide();//delete (effechowindow);
effchoruswindow->hide();//delete (effchoruswindow);
effphaserwindow->hide();//delete (effphaserwindow);
effalienwahwindow->hide();//delete (effalienwahwindow);
effdistorsionwindow->hide();//delete (effdistorsionwindow);
effeqwindow->hide();//delete (effeqwindow);
effdynamicfilterwindow->hide();//delete (effdynamicfilterwindow);

if (filterwindow!=NULL){
	filterwindow->hide();
	delete(filterwindow);
};
}

Fl_Group* EffUI::make_null_window() {
  Fl_Group* w;
  { Fl_Group* o = effnullwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(120, 35, 10, 20, "No Effect");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->labelcolor((Fl_Color)43);
      o->align(FL_ALIGN_RIGHT);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_reverb_window() {
  Fl_Group* w;
  { Fl_Group* o = effreverbwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(275, 10, 10, 20, "Reverb ");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { Fl_Choice* o = revp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_revp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_revp);
    }
    { Fl_Choice* o = revp10 = new Fl_Choice(110, 15, 75, 15, "Type");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_revp10);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_revp10);
    }
    { WidgetPDial* o = revp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp2 = new WidgetPDial(80, 40, 30, 30, "Time");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp3 = new WidgetPDial(120, 40, 30, 30, "I.del");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = revp4 = new WidgetPDial(155, 40, 30, 30, "I.delfb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp4);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp5 = new WidgetPDial(200, 40, 30, 30, "R.delay");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
      o->deactivate();
    }
    { WidgetPDial* o = revp6 = new WidgetPDial(235, 40, 30, 30, "E/R");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
      o->deactivate();
    }
    { WidgetPDial* o = revp7 = new WidgetPDial(270, 40, 30, 30, "LPF");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp7);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp8 = new WidgetPDial(305, 40, 30, 30, "HPF");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp8);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp9 = new WidgetPDial(340, 40, 30, 30, "Damp");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->minimum(64);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_revp9);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp11 = new WidgetPDial(190, 10, 25, 25, "R.S.");
      o->tooltip("RoomSize");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(8);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->minimum(1);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_revp11);
      o->align(FL_ALIGN_RIGHT);
      o->when(FL_WHEN_CHANGED);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_echo_window() {
  Fl_Group* w;
  { Fl_Group* o = effechowindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = echop = new Fl_Choice(11, 15, 95, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_echop);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_echop);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(295, 10, 10, 20, "Echo");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = echop0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = echop1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = echop2 = new WidgetPDial(80, 40, 30, 30, "Delay");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = echop3 = new WidgetPDial(120, 40, 30, 30, "LRdl.");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = echop4 = new WidgetPDial(155, 40, 30, 30, "LRc.");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop4);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = echop5 = new WidgetPDial(195, 40, 30, 30, "Fb.");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = echop6 = new WidgetPDial(235, 40, 30, 30, "Damp");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_chorus_window() {
  Fl_Group* w;
  { Fl_Group* o = effchoruswindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = chorusp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_chorusp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_chorusp);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(265, 10, 10, 20, "Chorus");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = chorusp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp2 = new WidgetPDial(85, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp3 = new WidgetPDial(120, 40, 30, 30, "Rnd");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = chorusp5 = new WidgetPDial(200, 40, 30, 30, "St.df");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp6 = new WidgetPDial(235, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp7 = new WidgetPDial(270, 40, 30, 30, "Delay");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp7);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp8 = new WidgetPDial(305, 40, 30, 30, "Fb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp8);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp9 = new WidgetPDial(340, 40, 30, 30, "L/R");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp9);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(120, 10, 55, 20, "Flange");
      o->box(FL_THIN_UP_BOX);
      o->down_box(FL_DOWN_BOX);
      o->color((Fl_Color)230);
      o->labelfont(1);
      o->labelsize(10);
      o->callback((Fl_Callback*)cb_Flange);
      o->hide();
      o->deactivate();
      o->value(eff->geteffectpar(10));
    }
    { Fl_Check_Button* o = chorusp11 = new Fl_Check_Button(185, 10, 70, 20, "Substract");
      o->box(FL_THIN_UP_BOX);
      o->down_box(FL_DOWN_BOX);
      o->color((Fl_Color)230);
      o->labelfont(1);
      o->labelsize(10);
      o->callback((Fl_Callback*)cb_chorusp11);
    }
    { Fl_Choice* o = chorusp4 = new Fl_Choice(155, 50, 40, 15, "LFO type");
      o->tooltip("LFO function");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(8);
      o->callback((Fl_Callback*)cb_chorusp4);
      o->align(130);
      o->menu(menu_chorusp4);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_phaser_window() {
  Fl_Group* w;
  { Fl_Group* o = effphaserwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = phaserp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_phaserp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_phaserp);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(275, 10, 10, 20, "Phaser");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = phaserp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp2 = new WidgetPDial(85, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp3 = new WidgetPDial(120, 40, 30, 30, "Rnd");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = phaserp5 = new WidgetPDial(200, 40, 30, 30, "St.df");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp6 = new WidgetPDial(235, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp7 = new WidgetPDial(270, 40, 30, 30, "Fb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp7);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp9 = new WidgetPDial(345, 40, 30, 30, "L/R");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp9);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Check_Button* o = phaserp10 = new Fl_Check_Button(185, 10, 70, 20, "Substract");
      o->box(FL_THIN_UP_BOX);
      o->down_box(FL_DOWN_BOX);
      o->color((Fl_Color)230);
      o->labelfont(1);
      o->labelsize(10);
      o->callback((Fl_Callback*)cb_phaserp10);
    }
    { Fl_Choice* o = phaserp4 = new Fl_Choice(155, 50, 40, 15, "LFO type");
      o->tooltip("LFO function");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(8);
      o->callback((Fl_Callback*)cb_phaserp4);
      o->align(130);
      o->menu(menu_phaserp4);
    }
    { Fl_Counter* o = phaserp8 = new Fl_Counter(305, 55, 35, 15, "Stages");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_phaserp8);
      o->range(1,MAX_PHASER_STAGES);
    }
    { WidgetPDial* o = phaserp11 = new WidgetPDial(155, 10, 25, 25, "Phase");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(10);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp11);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_alienwah_window() {
  Fl_Group* w;
  { Fl_Group* o = effalienwahwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = awp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_awp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_awp);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(245, 10, 10, 20, "AlienWah");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = awp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp2 = new WidgetPDial(85, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp3 = new WidgetPDial(120, 40, 30, 30, "Rnd");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = awp5 = new WidgetPDial(200, 40, 30, 30, "St.df");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp6 = new WidgetPDial(235, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp7 = new WidgetPDial(270, 40, 30, 30, "Fb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp7);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp9 = new WidgetPDial(345, 40, 30, 30, "L/R");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp9);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Choice* o = awp4 = new Fl_Choice(155, 50, 40, 15, "LFO type");
      o->tooltip("LFO function");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(8);
      o->callback((Fl_Callback*)cb_awp4);
      o->align(130);
      o->menu(menu_awp4);
    }
    { WidgetPDial* o = awp10 = new WidgetPDial(160, 5, 30, 30, "Phase");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp10);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Counter* o = awp8 = new Fl_Counter(305, 55, 35, 15, "Delay");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_awp8);
      o->range(1,MAX_ALIENWAH_DELAY);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_distorsion_window() {
  Fl_Group* w;
  { Fl_Group* o = effdistorsionwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = distp = new Fl_Choice(11, 15, 95, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_distp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_distp);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(230, 10, 10, 20, "Distortion");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = distp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp2 = new WidgetPDial(80, 40, 30, 30, "LRc.");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = distp3 = new WidgetPDial(120, 40, 30, 30, "Drive");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = distp4 = new WidgetPDial(155, 40, 30, 30, "Level");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp4);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp7 = new WidgetPDial(285, 40, 30, 30, "LPF");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp7);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp8 = new WidgetPDial(320, 40, 30, 30, "HPF");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp8);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Choice* o = distp5 = new Fl_Choice(190, 50, 60, 20, "Type");
      o->box(FL_UP_BOX);
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->textsize(10);
      o->callback((Fl_Callback*)cb_distp5);
      o->align(FL_ALIGN_BOTTOM);
      o->menu(menu_distp5);
    }
    { Fl_Check_Button* o = distp6 = new Fl_Check_Button(260, 55, 15, 15, "Neg.");
      o->down_box(FL_DOWN_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_distp6);
      o->align(FL_ALIGN_BOTTOM);
    }
    { Fl_Check_Button* o = distp9 = new Fl_Check_Button(355, 60, 15, 15, "St.");
      o->tooltip("Stereo");
      o->down_box(FL_DOWN_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_distp9);
      o->align(FL_ALIGN_BOTTOM);
    }
    { Fl_Check_Button* o = distp10 = new Fl_Check_Button(355, 44, 15, 15, "PF");
      o->tooltip("Applies the filters(before or after) the distorsion");
      o->down_box(FL_DOWN_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_distp10);
      o->align(FL_ALIGN_TOP);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_eq_window() {
  Fl_Group* w;
  { Fl_Group* o = effeqwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(320, 10, 15, 20, "EQ");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = eqp0 = new WidgetPDial(10, 35, 30, 30, "Gain");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_eqp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Counter* o = bandcounter = new Fl_Counter(240, 20, 45, 15, "B.");
      o->tooltip("Band no.");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(1);
      o->step(1);
      o->textfont(1);
      o->textsize(12);
      o->callback((Fl_Callback*)cb_bandcounter);
      o->align(FL_ALIGN_TOP);
      o->bounds(0,MAX_EQ_BANDS-1);
    }
    { Fl_Group* o = bandgroup = new Fl_Group(245, 40, 130, 50);
      o->box(FL_ENGRAVED_FRAME);
      { WidgetPDial* o = freqdial = new WidgetPDial(250, 50, 25, 25, "Freq");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_freqdial);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { WidgetPDial* o = gaindial = new WidgetPDial(280, 50, 25, 25, "Gain");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->step(1);
        o->callback((Fl_Callback*)cb_gaindial);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { WidgetPDial* o = qdial = new WidgetPDial(310, 50, 25, 25, "Q");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_qdial);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { Fl_Counter* o = stagescounter = new Fl_Counter(340, 60, 30, 15, "St.");
        o->tooltip("Additional filter stages");
        o->type(1);
        o->labelfont(1);
        o->labelsize(10);
        o->minimum(1);
        o->maximum(127);
        o->step(1);
        o->textfont(1);
        o->textsize(12);
        o->callback((Fl_Callback*)cb_stagescounter);
        o->bounds(0,MAX_FILTER_STAGES-1);
      }
      if (eff->geteffectpar(10)==0) o->deactivate();
      o->end();
    }
    { Fl_Choice* o = typechoice = new Fl_Choice(290, 20, 40, 15, "T.");
      o->tooltip("Type");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(10);
      o->callback((Fl_Callback*)cb_typechoice);
      o->align(FL_ALIGN_TOP);
      o->when(FL_WHEN_RELEASE_ALWAYS);
      o->menu(menu_typechoice);
    }
    { EQGraph* o = eqgraph = new EQGraph(45, 10, 190, 75);
      o->box(FL_BORDER_BOX);
      o->color((Fl_Color)178);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
      o->init(eff);
    }
    o->end();
  }
  return w;
}

Fl_Group* EffUI::make_dynamicfilter_window() {
  Fl_Group* w;
  { Fl_Group* o = effdynamicfilterwindow = new Fl_Group(0, 0, 380, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = dfp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_dfp);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_dfp);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(245, 10, 10, 20, "DynFilter");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = dfp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp0);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp1 = new WidgetPDial(45, 40, 30, 30, "Pan");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp1);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp2 = new WidgetPDial(85, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp2);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp3 = new WidgetPDial(120, 40, 30, 30, "Rnd");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp3);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = dfp5 = new WidgetPDial(200, 40, 30, 30, "St.df");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp5);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp6 = new WidgetPDial(235, 40, 30, 30, "LfoD");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp6);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Choice* o = dfp4 = new Fl_Choice(155, 50, 40, 15, "LFO type");
      o->tooltip("LFO function");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(8);
      o->callback((Fl_Callback*)cb_dfp4);
      o->align(130);
      o->menu(menu_dfp4);
    }
    { Fl_Button* o = new Fl_Button(115, 10, 55, 25, "Filter");
      o->box(FL_PLASTIC_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Filter);
    }
    { Fl_Group* o = new Fl_Group(270, 40, 105, 45);
      o->box(FL_BORDER_BOX);
      o->color((Fl_Color)181);
      { WidgetPDial* o = dfp7 = new WidgetPDial(275, 45, 25, 25, "A.S.");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(12);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_dfp7);
        o->align(FL_ALIGN_BOTTOM);
        o->when(FL_WHEN_CHANGED);
      }
      { WidgetPDial* o = dfp9 = new WidgetPDial(305, 45, 25, 25, "A.M");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(12);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_dfp9);
        o->align(FL_ALIGN_BOTTOM);
        o->when(FL_WHEN_CHANGED);
      }
      { Fl_Check_Button* o = dfp8 = new Fl_Check_Button(345, 55, 15, 15, "A.Inv.");
        o->down_box(FL_DOWN_BOX);
        o->labelfont(1);
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_dfp8);
        o->align(FL_ALIGN_BOTTOM);
      }
      o->end();
    }
    o->end();
  }
  return w;
}

Fl_Double_Window* EffUI::make_filter_window() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = filterwindow = new Fl_Double_Window(290, 110, "Filter Parameters for DynFilter Eff.");
    w = o;
    o->user_data((void*)(this));
    { FilterUI* o = new FilterUI(5, 5, 275, 75, "DynFilter effect  - Filter");
      o->box(FL_FLAT_BOX);
      o->color(FL_LIGHT1);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE);
      o->when(FL_WHEN_RELEASE);
      o->init(eff->filterpars,NULL,NULL);
      o->use_for_dynamic_filter();
      o->end();
    }
    { Fl_Button* o = new Fl_Button(105, 85, 70, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close);
    }
    o->end();
  }
  return w;
}

void EffUI::init(EffectMgr *eff_) {
  eff=eff_;

make_null_window();
make_reverb_window();
make_echo_window();
make_chorus_window();
make_phaser_window();
make_alienwah_window();
make_distorsion_window();
make_eq_window();
make_dynamicfilter_window();

int px=this->parent()->x();
int py=this->parent()->y();

effnullwindow->position(px,py);
effreverbwindow->position(px,py);
effechowindow->position(px,py);
effchoruswindow->position(px,py);
effphaserwindow->position(px,py);
effalienwahwindow->position(px,py);
effdistorsionwindow->position(px,py);
effeqwindow->position(px,py);
effdynamicfilterwindow->position(px,py);

refresh(eff);
}

void EffUI::refresh(EffectMgr *eff_) {
  eff=eff_;
this->hide();

effnullwindow->hide();
effreverbwindow->hide();
effechowindow->hide();
effchoruswindow->hide();
effphaserwindow->hide();
effalienwahwindow->hide();
effdistorsionwindow->hide();
effeqwindow->hide();
effdynamicfilterwindow->hide();

eqband=0;

if (filterwindow!=NULL){
	filterwindow->hide();
	delete(filterwindow);
	filterwindow=NULL;
};

switch(eff->geteffect()){
     case 1:
	revp->value(eff->getpreset());
	revp0->value(eff->geteffectpar(0));if (eff->insertion!=0) revp0->label("D/W");
	revp1->value(eff->geteffectpar(1));
	revp2->value(eff->geteffectpar(2));
	revp3->value(eff->geteffectpar(3));
	revp4->value(eff->geteffectpar(4));
	revp5->value(eff->geteffectpar(5));
	revp6->value(eff->geteffectpar(6));
	revp7->value(eff->geteffectpar(7));
	revp8->value(eff->geteffectpar(8));
	revp9->value(eff->geteffectpar(9));
	revp10->value(eff->geteffectpar(10));
	revp11->value(eff->geteffectpar(11));
            
        effreverbwindow->show();
        break; 
     case 2:
	echop->value(eff->getpreset());
	echop0->value(eff->geteffectpar(0));if (eff->insertion!=0) echop0->label("D/W");
	echop1->value(eff->geteffectpar(1));
	echop2->value(eff->geteffectpar(2));
	echop3->value(eff->geteffectpar(3));
	echop4->value(eff->geteffectpar(4));
	echop5->value(eff->geteffectpar(5));
	echop6->value(eff->geteffectpar(6));
	effechowindow->show();
        break; 
     case 3:
	chorusp->value(eff->getpreset());
	chorusp0->value(eff->geteffectpar(0));if (eff->insertion!=0) chorusp0->label("D/W");
	chorusp1->value(eff->geteffectpar(1));
	chorusp2->value(eff->geteffectpar(2));
	chorusp3->value(eff->geteffectpar(3));
	chorusp4->value(eff->geteffectpar(4));
	chorusp5->value(eff->geteffectpar(5));
	chorusp6->value(eff->geteffectpar(6));
	chorusp7->value(eff->geteffectpar(7));
	chorusp8->value(eff->geteffectpar(8));
	chorusp9->value(eff->geteffectpar(9));
	chorusp11->value(eff->geteffectpar(11));
	effchoruswindow->show();
        break; 
     case 4:
	phaserp->value(eff->getpreset());
	phaserp0->value(eff->geteffectpar(0));if (eff->insertion!=0) phaserp0->label("D/W");
	phaserp1->value(eff->geteffectpar(1));
	phaserp2->value(eff->geteffectpar(2));
	phaserp3->value(eff->geteffectpar(3));
	phaserp4->value(eff->geteffectpar(4));
	phaserp5->value(eff->geteffectpar(5));
	phaserp6->value(eff->geteffectpar(6));
	phaserp7->value(eff->geteffectpar(7));
	phaserp8->value(eff->geteffectpar(8));
	phaserp9->value(eff->geteffectpar(9));
	phaserp10->value(eff->geteffectpar(10));
	phaserp11->value(eff->geteffectpar(11));
	effphaserwindow->show();
        break; 
     case 5:
	awp->value(eff->getpreset());
	awp0->value(eff->geteffectpar(0));if (eff->insertion!=0) awp0->label("D/W");
	awp1->value(eff->geteffectpar(1));
	awp2->value(eff->geteffectpar(2));
	awp3->value(eff->geteffectpar(3));
	awp4->value(eff->geteffectpar(4));
	awp5->value(eff->geteffectpar(5));
	awp6->value(eff->geteffectpar(6));
	awp7->value(eff->geteffectpar(7));
	awp8->value(eff->geteffectpar(8));
	awp9->value(eff->geteffectpar(9));
	awp10->value(eff->geteffectpar(10));

	effalienwahwindow->show();
        break; 
     case 6:
	distp->value(eff->getpreset());
	distp0->value(eff->geteffectpar(0));if (eff->insertion!=0) distp0->label("D/W");
	distp1->value(eff->geteffectpar(1));
	distp2->value(eff->geteffectpar(2));
	distp3->value(eff->geteffectpar(3));
	distp4->value(eff->geteffectpar(4));
	distp5->value(eff->geteffectpar(5));
	distp6->value(eff->geteffectpar(6));
	distp7->value(eff->geteffectpar(7));
	distp8->value(eff->geteffectpar(8));
	distp9->value(eff->geteffectpar(9));
	distp10->value(eff->geteffectpar(10));
	effdistorsionwindow->show();
        break;
     case 7:eqband=0;
	eqp0->value(eff->geteffectpar(0));
	bandcounter->value(eqband);
	bandcounter->do_callback();
	typechoice->value(eff->geteffectpar(10));
	eqgraph->redraw();
	freqdial->value(eff->geteffectpar(11));
	gaindial->value(eff->geteffectpar(12));
	if (eff->geteffectpar(10)<6) gaindial->deactivate();
	qdial->value(eff->geteffectpar(13));
	stagescounter->value(eff->geteffectpar(14));
        eqgraph->init(eff);
	effeqwindow->show();
        break;
     case 8:make_filter_window();
	dfp->value(eff->getpreset());
	dfp0->value(eff->geteffectpar(0));if (eff->insertion!=0) dfp0->label("D/W");
	dfp1->value(eff->geteffectpar(1));
	dfp2->value(eff->geteffectpar(2));
	dfp3->value(eff->geteffectpar(3));
	dfp4->value(eff->geteffectpar(4));
	dfp5->value(eff->geteffectpar(5));
	dfp6->value(eff->geteffectpar(6));
	dfp7->value(eff->geteffectpar(7));
	dfp8->value(eff->geteffectpar(8));
	dfp9->value(eff->geteffectpar(9));

            
	effdynamicfilterwindow->show();
	break;
    default:effnullwindow->show();
            break; 
};

this->show();
}

void EffUI::refresh() {
  refresh(eff);
}

void SimpleEffUI::cb_revpa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());

refresh(eff);
}
void SimpleEffUI::cb_revpa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_revpa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_revp1[] = {
 {"Cathedral 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Cathedral 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Cathedral 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Hall 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Hall 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Room 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Room 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Basement", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Tunnel", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echoed 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echoed 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Very Long 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Very Long 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_revp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_revp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_revp01_i(o,v);
}

void SimpleEffUI::cb_revp21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_revp21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_revp21_i(o,v);
}

void SimpleEffUI::cb_revp31_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void SimpleEffUI::cb_revp31(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_revp31_i(o,v);
}

void SimpleEffUI::cb_revp91_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void SimpleEffUI::cb_revp91(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_revp91_i(o,v);
}

void SimpleEffUI::cb_echop7_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_echop7(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_echop7_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_echop1[] = {
 {"Echo 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echo 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Echo 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Simple Echo", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Canyon", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Panning Echo 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Feedback Echo", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_echop01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_echop01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_echop01_i(o,v);
}

void SimpleEffUI::cb_echop21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_echop21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_echop21_i(o,v);
}

void SimpleEffUI::cb_echop51_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void SimpleEffUI::cb_echop51(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_echop51_i(o,v);
}

void SimpleEffUI::cb_choruspa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_choruspa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_choruspa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_chorusp1[] = {
 {"Chorus 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Chorus 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Chorus 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Celeste 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Celeste 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Flange 5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_chorusp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_chorusp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_chorusp01_i(o,v);
}

void SimpleEffUI::cb_chorusp21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_chorusp21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_chorusp21_i(o,v);
}

void SimpleEffUI::cb_chorusp61_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void SimpleEffUI::cb_chorusp61(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_chorusp61_i(o,v);
}

void SimpleEffUI::cb_chorusp71_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void SimpleEffUI::cb_chorusp71(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_chorusp71_i(o,v);
}

void SimpleEffUI::cb_chorusp81_i(WidgetPDial* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void SimpleEffUI::cb_chorusp81(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_chorusp81_i(o,v);
}

void SimpleEffUI::cb_Flange1_i(Fl_Check_Button* o, void*) {
  eff->seteffectpar(10,(int) o->value());
}
void SimpleEffUI::cb_Flange1(Fl_Check_Button* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_Flange1_i(o,v);
}

void SimpleEffUI::cb_phaserpa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_phaserpa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserpa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_phaserp1[] = {
 {"Phaser 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 5", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Phaser 6", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_phaserp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_phaserp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp01_i(o,v);
}

void SimpleEffUI::cb_phaserp21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_phaserp21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp21_i(o,v);
}

void SimpleEffUI::cb_phaserp51_i(WidgetPDial* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void SimpleEffUI::cb_phaserp51(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp51_i(o,v);
}

void SimpleEffUI::cb_phaserp61_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void SimpleEffUI::cb_phaserp61(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp61_i(o,v);
}

void SimpleEffUI::cb_phaserp71_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void SimpleEffUI::cb_phaserp71(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp71_i(o,v);
}

void SimpleEffUI::cb_phaserp81_i(Fl_Counter* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void SimpleEffUI::cb_phaserp81(Fl_Counter* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_phaserp81_i(o,v);
}

void SimpleEffUI::cb_awpa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_awpa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_awpa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_awp1[] = {
 {"Alienwah 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 3", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Alienwah 4", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_awp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_awp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_awp01_i(o,v);
}

void SimpleEffUI::cb_awp21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_awp21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_awp21_i(o,v);
}

void SimpleEffUI::cb_awp61_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void SimpleEffUI::cb_awp61(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_awp61_i(o,v);
}

void SimpleEffUI::cb_awp81_i(Fl_Counter* o, void*) {
  eff->seteffectpar(8,(int) o->value());
}
void SimpleEffUI::cb_awp81(Fl_Counter* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_awp81_i(o,v);
}

void SimpleEffUI::cb_distpa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_distpa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distpa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_distp1[] = {
 {"Overdrive 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Overdrive 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"A. Exciter 1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"A. Exciter 2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Guitar Amp", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Quantisize", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_distp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_distp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distp01_i(o,v);
}

void SimpleEffUI::cb_distp31_i(WidgetPDial* o, void*) {
  eff->seteffectpar(3,(int) o->value());
}
void SimpleEffUI::cb_distp31(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distp31_i(o,v);
}

void SimpleEffUI::cb_distp41_i(WidgetPDial* o, void*) {
  eff->seteffectpar(4,(int) o->value());
}
void SimpleEffUI::cb_distp41(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distp41_i(o,v);
}

void SimpleEffUI::cb_distp71_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void SimpleEffUI::cb_distp71(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distp71_i(o,v);
}

void SimpleEffUI::cb_distp51_i(Fl_Choice* o, void*) {
  eff->seteffectpar(5,(int) o->value());
}
void SimpleEffUI::cb_distp51(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_distp51_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_distp51[] = {
 {"Atan", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Asym1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pow", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Sine", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Qnts", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Zigzg", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lmt", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LmtU", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LmtL", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"ILmt", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Clip", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Asym2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pow2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Sgm", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_bandcounter1_i(Fl_Counter* o, void*) {
  eqband=(int) o->value();
int npb=eqband*5+10;

int type=eff->geteffectpar(npb);
typechoice->value(type);

if (type>6) gaindial->activate();
 else gaindial->deactivate();

if (type==0) bandgroup->deactivate();
else bandgroup->activate();

int freq=eff->geteffectpar(npb+1);
freqdial->value(freq);

int gain=eff->geteffectpar(npb+2);
gaindial->value(gain);

int q=eff->geteffectpar(npb+3);
qdial->value(q);

int dbl=eff->geteffectpar(npb+4);
stagescounter->value(dbl);
}
void SimpleEffUI::cb_bandcounter1(Fl_Counter* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_bandcounter1_i(o,v);
}

void SimpleEffUI::cb_freqdial1_i(WidgetPDial* o, void*) {
  int np=eqband*5+11;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void SimpleEffUI::cb_freqdial1(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_freqdial1_i(o,v);
}

void SimpleEffUI::cb_gaindial1_i(WidgetPDial* o, void*) {
  int np=eqband*5+12;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void SimpleEffUI::cb_gaindial1(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_gaindial1_i(o,v);
}

void SimpleEffUI::cb_qdial1_i(WidgetPDial* o, void*) {
  int np=eqband*5+13;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void SimpleEffUI::cb_qdial1(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_qdial1_i(o,v);
}

void SimpleEffUI::cb_stagescounter1_i(Fl_Counter* o, void*) {
  int np=eqband*5+14;
eff->seteffectpar(np,(int) o->value());
eqgraph->redraw();
}
void SimpleEffUI::cb_stagescounter1(Fl_Counter* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_stagescounter1_i(o,v);
}

void SimpleEffUI::cb_typechoice1_i(Fl_Choice* o, void*) {
  int np=eqband*5+10;
eff->seteffectpar(np,(int) o->value());
bandcounter->do_callback();
eqgraph->redraw();
}
void SimpleEffUI::cb_typechoice1(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_typechoice1_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_typechoice1[] = {
 {"OFF", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lp1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Hp1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Lp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Hp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Bp2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"N2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"Pk", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"LSh", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {"HSh", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_dfpa_i(Fl_Choice* o, void*) {
  eff->changepreset((int)o->value());
refresh(eff);
}
void SimpleEffUI::cb_dfpa(Fl_Choice* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_dfpa_i(o,v);
}

Fl_Menu_Item SimpleEffUI::menu_dfp1[] = {
 {"WahWah", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"AutoWah", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"Sweep", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"VocalMorph1", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {"VocalMorph2", 0,  0, 0, 0, FL_NORMAL_LABEL, 1, 10, 7},
 {0,0,0,0,0,0,0,0,0}
};

void SimpleEffUI::cb_dfp01_i(WidgetPDial* o, void*) {
  eff->seteffectpar(0,(int) o->value());
}
void SimpleEffUI::cb_dfp01(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_dfp01_i(o,v);
}

void SimpleEffUI::cb_dfp21_i(WidgetPDial* o, void*) {
  eff->seteffectpar(2,(int) o->value());
}
void SimpleEffUI::cb_dfp21(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_dfp21_i(o,v);
}

void SimpleEffUI::cb_dfp61_i(WidgetPDial* o, void*) {
  eff->seteffectpar(6,(int) o->value());
}
void SimpleEffUI::cb_dfp61(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->user_data()))->cb_dfp61_i(o,v);
}

void SimpleEffUI::cb_dfp71_i(WidgetPDial* o, void*) {
  eff->seteffectpar(7,(int) o->value());
}
void SimpleEffUI::cb_dfp71(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_dfp71_i(o,v);
}

void SimpleEffUI::cb_dfp91_i(WidgetPDial* o, void*) {
  eff->seteffectpar(9,(int) o->value());
}
void SimpleEffUI::cb_dfp91(WidgetPDial* o, void* v) {
  ((SimpleEffUI*)(o->parent()->parent()->user_data()))->cb_dfp91_i(o,v);
}

SimpleEffUI::SimpleEffUI(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  eff=NULL;
}

SimpleEffUI::~SimpleEffUI() {
  effnullwindow->hide();//delete (effnullwindow);
effreverbwindow->hide();//delete (effreverbwindow);
effechowindow->hide();//delete (effechowindow);
effchoruswindow->hide();//delete (effchoruswindow);
effphaserwindow->hide();//delete (effphaserwindow);
effalienwahwindow->hide();//delete (effalienwahwindow);
effdistorsionwindow->hide();//delete (effdistorsionwindow);
effeqwindow->hide();//delete (effeqwindow);
effdynamicfilterwindow->hide();//delete (effdynamicfilterwindow);
}

Fl_Group* SimpleEffUI::make_null_window() {
  Fl_Group* w;
  { Fl_Group* o = effnullwindow = new Fl_Group(0, 0, 233, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(25, 35, 35, 20, "No Effect");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->labelcolor((Fl_Color)43);
      o->align(FL_ALIGN_RIGHT);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_reverb_window() {
  Fl_Group* w;
  { Fl_Group* o = effreverbwindow = new Fl_Group(0, 0, 233, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(115, 10, 20, 20, "Reverb ");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { Fl_Choice* o = revp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_revpa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_revp1);
    }
    { WidgetPDial* o = revp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp2 = new WidgetPDial(45, 40, 30, 30, "Time");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = revp3 = new WidgetPDial(85, 40, 30, 30, "I.del");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_revp31);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = revp9 = new WidgetPDial(120, 40, 30, 30, "Damp");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->minimum(64);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_revp91);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_echo_window() {
  Fl_Group* w;
  { Fl_Group* o = effechowindow = new Fl_Group(0, 0, 231, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = echop = new Fl_Choice(11, 15, 95, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_echop7);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_echop1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(145, 10, 10, 20, "Echo");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = echop0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = echop2 = new WidgetPDial(45, 40, 30, 30, "Delay");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = echop5 = new WidgetPDial(80, 40, 30, 30, "Fb.");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_echop51);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_chorus_window() {
  Fl_Group* w;
  { Fl_Group* o = effchoruswindow = new Fl_Group(0, 0, 233, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = chorusp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_choruspa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_chorusp1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(120, 10, 10, 20, "Chorus");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = chorusp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp2 = new WidgetPDial(45, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp6 = new WidgetPDial(80, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp61);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp7 = new WidgetPDial(115, 40, 30, 30, "Delay");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp71);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = chorusp8 = new WidgetPDial(150, 40, 30, 30, "Fb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_chorusp81);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Check_Button* o = new Fl_Check_Button(120, 10, 55, 20, "Flange");
      o->box(FL_THIN_UP_BOX);
      o->down_box(FL_DOWN_BOX);
      o->color((Fl_Color)230);
      o->labelfont(1);
      o->labelsize(10);
      o->callback((Fl_Callback*)cb_Flange1);
      o->hide();
      o->deactivate();
      o->value(eff->geteffectpar(10));
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_phaser_window() {
  Fl_Group* w;
  { Fl_Group* o = effphaserwindow = new Fl_Group(0, 0, 232, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = phaserp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_phaserpa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_phaserp1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(125, 10, 10, 20, "Phaser");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = phaserp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp2 = new WidgetPDial(45, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp5 = new WidgetPDial(80, 40, 30, 30, "St.df");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp51);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp6 = new WidgetPDial(115, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp61);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = phaserp7 = new WidgetPDial(150, 40, 30, 30, "Fb");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_phaserp71);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Counter* o = phaserp8 = new Fl_Counter(185, 55, 35, 15, "Stages");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_phaserp81);
      o->range(1,MAX_PHASER_STAGES);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_alienwah_window() {
  Fl_Group* w;
  { Fl_Group* o = effalienwahwindow = new Fl_Group(0, 0, 234, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = awp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_awpa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_awp1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(100, 10, 10, 20, "AlienWah");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = awp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp2 = new WidgetPDial(45, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = awp6 = new WidgetPDial(85, 40, 30, 30, "Dpth");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_awp61);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Counter* o = awp8 = new Fl_Counter(125, 55, 35, 15, "Delay");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(127);
      o->step(1);
      o->callback((Fl_Callback*)cb_awp81);
      o->range(1,MAX_ALIENWAH_DELAY);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_distorsion_window() {
  Fl_Group* w;
  { Fl_Group* o = effdistorsionwindow = new Fl_Group(0, 0, 230, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = distp = new Fl_Choice(11, 15, 95, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_distpa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_distp1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(110, 10, 10, 20, "Distortion");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(20);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = distp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp3 = new WidgetPDial(45, 40, 30, 30, "Drive");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp31);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_RELEASE);
    }
    { WidgetPDial* o = distp4 = new WidgetPDial(80, 40, 30, 30, "Level");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp41);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = distp7 = new WidgetPDial(190, 40, 30, 30, "LPF");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_distp71);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Choice* o = distp5 = new Fl_Choice(120, 50, 60, 20, "Type");
      o->box(FL_UP_BOX);
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->textsize(10);
      o->callback((Fl_Callback*)cb_distp51);
      o->align(FL_ALIGN_BOTTOM);
      o->menu(menu_distp51);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_eq_window() {
  Fl_Group* w;
  { Fl_Group* o = effeqwindow = new Fl_Group(0, 0, 230, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Text_Display* o = new Fl_Text_Display(170, 5, 15, 25, "EQ");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { Fl_Counter* o = bandcounter = new Fl_Counter(85, 15, 45, 15, "Band");
      o->tooltip("Band no.");
      o->type(1);
      o->labelfont(1);
      o->labelsize(12);
      o->minimum(0);
      o->maximum(1);
      o->step(1);
      o->textfont(1);
      o->textsize(12);
      o->callback((Fl_Callback*)cb_bandcounter1);
      o->align(FL_ALIGN_TOP);
      o->bounds(0,MAX_EQ_BANDS-1);
    }
    { Fl_Group* o = bandgroup = new Fl_Group(5, 5, 75, 85);
      o->box(FL_ENGRAVED_FRAME);
      { WidgetPDial* o = freqdial = new WidgetPDial(10, 10, 25, 25, "Freq");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_freqdial1);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { WidgetPDial* o = gaindial = new WidgetPDial(45, 10, 25, 25, "Gain");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->step(1);
        o->callback((Fl_Callback*)cb_gaindial1);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { WidgetPDial* o = qdial = new WidgetPDial(10, 50, 25, 25, "Q");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(10);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_qdial1);
        o->align(FL_ALIGN_BOTTOM);
        o->when(3);
      }
      { Fl_Counter* o = stagescounter = new Fl_Counter(40, 55, 30, 15, "Stages");
        o->tooltip("Additional filter stages");
        o->type(1);
        o->labelfont(1);
        o->labelsize(10);
        o->minimum(1);
        o->maximum(127);
        o->step(1);
        o->textfont(1);
        o->textsize(12);
        o->callback((Fl_Callback*)cb_stagescounter1);
        o->bounds(0,MAX_FILTER_STAGES-1);
      }
      if (eff->geteffectpar(10)==0) o->deactivate();
      o->end();
    }
    { Fl_Choice* o = typechoice = new Fl_Choice(135, 15, 40, 15, "Type");
      o->tooltip("Type");
      o->down_box(FL_BORDER_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->textsize(10);
      o->callback((Fl_Callback*)cb_typechoice1);
      o->align(FL_ALIGN_TOP);
      o->when(FL_WHEN_RELEASE_ALWAYS);
      o->menu(menu_typechoice1);
    }
    { EQGraph* o = eqgraph = new EQGraph(85, 35, 140, 55);
      o->box(FL_BORDER_BOX);
      o->color((Fl_Color)178);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
      o->init(eff);
    }
    o->end();
  }
  return w;
}

Fl_Group* SimpleEffUI::make_dynamicfilter_window() {
  Fl_Group* w;
  { Fl_Group* o = effdynamicfilterwindow = new Fl_Group(0, 0, 232, 95);
    w = o;
    o->box(FL_PLASTIC_UP_BOX);
    o->color((Fl_Color)221);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(1);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Choice* o = dfp = new Fl_Choice(10, 15, 90, 15, "Preset");
      o->down_box(FL_BORDER_BOX);
      o->color((Fl_Color)14);
      o->selection_color(FL_FOREGROUND_COLOR);
      o->labelfont(1);
      o->labelsize(10);
      o->textfont(1);
      o->textsize(10);
      o->textcolor(7);
      o->callback((Fl_Callback*)cb_dfpa);
      o->align(FL_ALIGN_TOP_LEFT);
      o->menu(menu_dfp1);
    }
    { Fl_Text_Display* o = new Fl_Text_Display(100, 10, 10, 20, "DynFilter");
      o->box(FL_NO_BOX);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(1);
      o->labelsize(26);
      o->align(FL_ALIGN_RIGHT);
    }
    { WidgetPDial* o = dfp0 = new WidgetPDial(10, 40, 30, 30, "Vol");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp01);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp2 = new WidgetPDial(45, 40, 30, 30, "Freq");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp21);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { WidgetPDial* o = dfp6 = new WidgetPDial(80, 40, 30, 30, "LfoD");
      o->box(FL_ROUND_UP_BOX);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_INACTIVE_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor(FL_FOREGROUND_COLOR);
      o->maximum(127);
      o->callback((Fl_Callback*)cb_dfp61);
      o->align(FL_ALIGN_BOTTOM);
      o->when(FL_WHEN_CHANGED);
    }
    { Fl_Group* o = new Fl_Group(115, 40, 65, 45);
      o->box(FL_BORDER_BOX);
      o->color((Fl_Color)181);
      { WidgetPDial* o = dfp7 = new WidgetPDial(120, 45, 25, 25, "A.S.");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(12);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_dfp71);
        o->align(FL_ALIGN_BOTTOM);
        o->when(FL_WHEN_CHANGED);
      }
      { WidgetPDial* o = dfp9 = new WidgetPDial(150, 45, 25, 25, "A.M");
        o->box(FL_ROUND_UP_BOX);
        o->color(FL_BACKGROUND_COLOR);
        o->selection_color(FL_INACTIVE_COLOR);
        o->labeltype(FL_NORMAL_LABEL);
        o->labelfont(1);
        o->labelsize(12);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->maximum(127);
        o->callback((Fl_Callback*)cb_dfp91);
        o->align(FL_ALIGN_BOTTOM);
        o->when(FL_WHEN_CHANGED);
      }
      o->end();
    }
    o->end();
  }
  return w;
}

void SimpleEffUI::init(EffectMgr *eff_) {
  eff=eff_;

make_null_window();
make_reverb_window();
make_echo_window();
make_chorus_window();
make_phaser_window();
make_alienwah_window();
make_distorsion_window();
make_eq_window();
make_dynamicfilter_window();

int px=this->parent()->x();
int py=this->parent()->y();

effnullwindow->position(px,py);
effreverbwindow->position(px,py);
effechowindow->position(px,py);
effchoruswindow->position(px,py);
effphaserwindow->position(px,py);
effalienwahwindow->position(px,py);
effdistorsionwindow->position(px,py);
effeqwindow->position(px,py);
effdynamicfilterwindow->position(px,py);

refresh(eff);
}

void SimpleEffUI::refresh(EffectMgr *eff_) {
  eff=eff_;
this->hide();

effnullwindow->hide();
effreverbwindow->hide();
effechowindow->hide();
effchoruswindow->hide();
effphaserwindow->hide();
effalienwahwindow->hide();
effdistorsionwindow->hide();
effeqwindow->hide();
effdynamicfilterwindow->hide();

eqband=0;


switch(eff->geteffect()){
     case 1:
	revp->value(eff->getpreset());
	revp0->value(eff->geteffectpar(0));if (eff->insertion!=0) revp0->label("D/W");
	revp2->value(eff->geteffectpar(2));
	revp3->value(eff->geteffectpar(3));
	revp9->value(eff->geteffectpar(9));          
        effreverbwindow->show();
        break; 
     case 2:
	echop->value(eff->getpreset());
	echop0->value(eff->geteffectpar(0));if (eff->insertion!=0) echop0->label("D/W");
	echop2->value(eff->geteffectpar(2));
	echop5->value(eff->geteffectpar(5));
	effechowindow->show();
        break; 
     case 3:
	chorusp->value(eff->getpreset());
	chorusp0->value(eff->geteffectpar(0));if (eff->insertion!=0) chorusp0->label("D/W");
	chorusp2->value(eff->geteffectpar(2));
	chorusp6->value(eff->geteffectpar(6));
	chorusp7->value(eff->geteffectpar(7));
	chorusp8->value(eff->geteffectpar(8));
	effchoruswindow->show();
        break; 
     case 4:
	phaserp->value(eff->getpreset());
	phaserp0->value(eff->geteffectpar(0));if (eff->insertion!=0) phaserp0->label("D/W");
	phaserp2->value(eff->geteffectpar(2));
	phaserp5->value(eff->geteffectpar(5));
	phaserp6->value(eff->geteffectpar(6));
	phaserp7->value(eff->geteffectpar(7));
	phaserp8->value(eff->geteffectpar(8));
	effphaserwindow->show();
        break; 
     case 5:
	awp->value(eff->getpreset());
	awp0->value(eff->geteffectpar(0));if (eff->insertion!=0) awp0->label("D/W");
	awp2->value(eff->geteffectpar(2));
	awp6->value(eff->geteffectpar(6));
	awp8->value(eff->geteffectpar(8));
	effalienwahwindow->show();
        break; 
     case 6:
	distp->value(eff->getpreset());
	distp0->value(eff->geteffectpar(0));if (eff->insertion!=0) distp0->label("D/W");
	distp3->value(eff->geteffectpar(3));
	distp4->value(eff->geteffectpar(4));
	distp5->value(eff->geteffectpar(5));
	distp7->value(eff->geteffectpar(7));
	effdistorsionwindow->show();
        break;
     case 7:
	bandcounter->value(eqband);
	bandcounter->do_callback();
	typechoice->value(eff->geteffectpar(10));
	eqgraph->redraw();
	freqdial->value(eff->geteffectpar(11));
	gaindial->value(eff->geteffectpar(12));
	if (eff->geteffectpar(10)<6) gaindial->deactivate();
	qdial->value(eff->geteffectpar(13));
	stagescounter->value(eff->geteffectpar(14));
        eqgraph->init(eff);
	effeqwindow->show();
        break;
     case 8:
	dfp->value(eff->getpreset());
	dfp0->value(eff->geteffectpar(0));if (eff->insertion!=0) dfp0->label("D/W");
	dfp2->value(eff->geteffectpar(2));
	dfp6->value(eff->geteffectpar(6));
	dfp7->value(eff->geteffectpar(7));
	dfp9->value(eff->geteffectpar(9));

            
	effdynamicfilterwindow->show();
	break;
    default:effnullwindow->show();
            break; 
};

this->show();
}

void SimpleEffUI::refresh() {
  refresh(eff);
}
